/***************************************************************************
 *   Copyright (C) 2005-2008 by Georg Hennig                               *
 *   Email: georg.hennig@web.de                                            *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef _KOMPARATORJOB_H_
#define _KOMPARATORJOB_H_

#include <qthread.h>

#include <kapplication.h>

class KomparatorJob : public QObject, public QThread
{
	Q_OBJECT

	public:
		KomparatorJob( QWidget *_parent );
		virtual ~KomparatorJob();

		void start();
		void stop();
		virtual void run();

		bool isCanceled();

	protected:
		bool m_canceled, m_initialized;

		void emitProgress( QString str, int percent );
		void emitMessage( const QString &message, const QString &title );

		QWidget *m_parent;
		QMutex m_mutex;

		int m_running;
		int m_progress;
		int m_total;
		QString m_status;

		void incrementProgress();
};

#endif
